<!DOCTYPE html>

<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Task 68</title>

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome Icons -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">
</head>

<body class="hold-transition sidebar-mini">

    <div class="wrapper">
        <!-- Navbar -->
        <nav class="main-header navbar navbar-expand navbar-white navbar-light">
            <!-- Left navbar links -->
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                </li>
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="#" class="nav-link">Home</a>
                </li>
            </ul>
        </nav>
        <!-- /.navbar -->
        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="#" class="brand-link">
                <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
                    style="opacity: .8">
                <span class="brand-text font-weight-light">Devcamp 120</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">
                <!-- Sidebar user panel (optional) -->
                <div class="user-panel mt-3 pb-3 mb-3 d-flex">
                    <div class="image">
                        <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
                    </div>
                    <div class="info">
                        <a href="#" class="d-block">Hồ Bá TRường</a>
                    </div>
                </div>


                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                        data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
                        <li class="nav-item menu-open">
                            <a href="Country.html" class="nav-link">
                                <i class="nav-icon fas fa-tachometer-alt"></i>
                                <p>
                                    Quay về Country
                                    <i class="right fas fa-angle-left"></i>
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="Region.html" class="nav-link active">
                                <i class="far fa-circle nav-icon"></i>
                                <p>
                                    Region list
                                </p>
                            </a>
                        </li>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <div class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-6">
                            <h2>DANH SÁCH REGION</h2>
                        </div><!-- /.col -->
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="#">Home</a></li>
                                <li class="breadcrumb-item active">Region list</li>
                            </ol>
                        </div><!-- /.col -->
                    </div><!-- /.row -->
                </div><!-- /.container-fluid -->
            </div>
            <!-- /.content-header -->

            <!-- Main content -->
            <div class="content">
                <div class="container-fluid">
                    <div class="row">
                        <button class="btn btn-primary" id="btn-create"><i class="fa-solid fa-plus"></i> &nbsp; Create
                            Region</button>
                        <div class="col-12">
                            <table class="table table-bregioned table-striped table-hover" id="region-table">
                                <thead>
                                    <tr>
                                        <th>ID</th>
                                        <th>Mã Region</th>
                                        <th>Tên Region</th>
                                        <th>Action</th>
                                        <th>DS District</th>
                                    </tr>
                            </table>
                            <!-- Vùng Modal -->
                            <!-- Create region modal -->
                            <div>
                                <div id="create-region-modal" class="modal fade" tabindex="-1">
                                    <div class="modal-dialog">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title" id="h5-modal-title">Create region
                                                </h5>
                                                <button class="close" data-dismiss="modal">&times;</button>
                                            </div>
                                            <div class="modal-body">
                                                <form>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Mã Region</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-create-regionCode"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Tên Region</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-create-regionName"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                </form>
                                            </div>
                                            <div class="modal-footer">
                                                <button class="btn btn-secondary" id="btn-create-cancel"
                                                    data-dismiss="modal">Cancel</button>
                                                <button class="btn btn-primary" id="btn-create-region">Create
                                                    Region</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <!-- Update region modal -->
                            <div>
                                <div id="update-region-modal" class="modal fade" tabindex="-1">
                                    <div class="modal-dialog">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title" id="h5-modal-title">Update Trạng Thái region
                                                </h5>
                                                <button class="close" data-dismiss="modal">&times;</button>
                                            </div>
                                            <div class="modal-body">
                                                <form>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Mã Region</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-update-regionCode"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Tên Region</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-update-regionName"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                </form>
                                            </div>
                                            <div class="modal-footer">
                                                <button class="btn btn-secondary" id="btn-update-cancel"
                                                    data-dismiss="modal">Cancel</button>
                                                <button class="btn btn-primary" id="btn-update-region">Update Trạng
                                                    Thái</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <!-- Delete confirm modal -->
                            <div>
                                <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
                                    <div class="modal-dialog">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title" id="h5-modal-title">Region Delete Confirmation
                                                </h5>
                                                <button class="close" data-dismiss="modal">&times;</button>
                                            </div>
                                            <div class="modal-body">
                                                <label>Bạn có chắc chắn muốn xóa region này không?</label>
                                            </div>
                                            <div class="modal-footer">
                                                <button class="btn btn-danger"
                                                    id="btn-confirm-delete-region">Confirm</button>
                                                <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <!-- region Detail modal -->
                            <div>

                            </div>
                        </div>
                    </div>
                    <!-- /.row -->
                </div><!-- /.container-fluid -->
            </div>
            <!-- /.content -->
        </div>
        <!-- Main Footer -->
        <footer class="main-footer">
            <!-- To the right -->
            <div class="float-right d-none d-sm-inline">
                DANH SÁCH ĐƠN HÀNG
            </div>
            <!-- Default to the left -->
            <strong>Copyright &copy; 2023 Devcamp 120.</strong> All rights
            reserved.
        </footer>
    </div>
    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <script>
        "use strict";
        $(document).ready(function () {
            /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
            const gBASE_URL = "http://localhost:8080/region/";

            const gCOLUMN_ID = 0;
            const gCOLUMN_REGION_CODE = 1;
            const gCOLUMN_REGION_NAME = 2;
            const gCOLUMN_ACTION = 3;
            const gCOLUMN_DS_DISTRICT = 4;

            const gCOLUMN = ["id", "regionCode", "regionName", "action","dsdistrict"];

            var gRegion_code = {
                id: "",
            }
            // định nghĩa table  - chưa có data
            var gregionTable = $("#region-table").DataTable({
                // Khai báo các cột của datatable
                "columns": [
                    { "data": gCOLUMN[gCOLUMN_ID] },
                    { "data": gCOLUMN[gCOLUMN_REGION_CODE] },
                    { "data": gCOLUMN[gCOLUMN_REGION_NAME] },
                    { "data": gCOLUMN[gCOLUMN_ACTION] },
                    { "data": gCOLUMN[gCOLUMN_DS_DISTRICT] }
                ],
                // Ghi đè nội dung của cột action, chuyển thành button chi tiết
                "columnDefs": [
                    {
                        "targets": gCOLUMN_ACTION,
                        "defaultContent": '<i class="fas fa-pen text-info edit-region"></i> &nbsp &nbsp &nbsp <i class="fas fa-trash text-danger delete-region"></i>'
                    },
                    {
                        "targets": gCOLUMN_DS_DISTRICT,
                        "defaultContent": '<button class="btn btn-primary district-region">Danh sách Region</button>'
                    }
                ]
            });

            /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
            onPageLoading();
            $("#btn-create").on("click", function () {
                $("#create-region-modal").modal("show");
            });
            $("#btn-create-region").on("click", function () {
                onCreateregion();
            });
            $("#region-table").on("click", ".edit-region", function () {
                onButtonChiTietClick(this); // this là button được ấn
            });
            // khi ấn nút sự kiện update trên modal
            $("#btn-update-region").on("click", function () {
                onBtnUpdateClick();
            });
            // khi ấn sự kiện delete
            $("#region-table").on("click", ".delete-region", function () {
                onBtnDeleteConfirmregionClick(this);
            });
            // gán sự kiện cho nút Delete  (trên modal)
            $("#btn-confirm-delete-region").on("click", function () {
                onBtnDeleteregionClick();
            });
            $("#region-table").on("click", ".district-region", function () {
                onBtnToDistrictClick(this);
            });
            /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
            // Hàm sự kiện thêm region
            function onCreateregion() {
                // khai báo dữ liệu
                var vregionObj = {
                    regionCode: "",
                    regionName: ""
                }
                // thu thập thông tin 
                getCreateData(vregionObj);
                // validate
                if (kiemtraCreateData(vregionObj)) {
                    // Tạo mới region
                    createRegion(vregionObj);
                }
            }
            // hàm thu thập thông tin để create region
            function getCreateData(paramObj) {
                paramObj.regionCode = $("#input-create-regionCode").val();
                paramObj.regionName = $("#input-create-regionName").val();
            }
            function kiemtraCreateData(paramObj) {
                if (paramObj.regionCode == "") {
                    alert("Bạn điền mã region không hợp lệ")
                    return false;
                }
                if (paramObj.regionName == "") {
                    alert("Bạn điền tên region không hợp lệ")
                    return false;
                }
                return true;
            }
            //Hàm tạo đơn mói
            function createRegion(paramObj) {
                var vUrlString = window.location.href; //đường đẫn gọi đến trang
                var vUrl = new URL(vUrlString);
                var vID = vUrl.searchParams.get("id");
                $.ajax({
                    url: gBASE_URL + "create/" + vID,
                    type: 'POST',
                    data: JSON.stringify(paramObj),
                    contentType: "application/json; charset=utf-8",
                    dataType: 'json',
                    success: function (paramObjregion) {
                        //hiển thị dữ liệu lên web
                        console.log(paramObjregion);
                        onPageLoading();
                        $("#create-region-modal").modal("hide");
                        alert("Bạn tạo thành công region");
                        $("#input-create-regionCode").val("");
                        $("#input-create-regionName").val("");
                    },
                    error: function (error) {
                        alert("Bạn tạo region thất bại!");
                        console.log(error.responseText)
                    }
                });
            }
            // infoFunction sẽ là function các nút cùng gọi
            function onButtonChiTietClick(paramChiTietButton) {
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramChiTietButton).parents('tr');
                //Lấy datatable row
                var vDatatableRow = gregionTable.row(vRowSelected);
                //Lấy data của dòng 
                var vregionData = vDatatableRow.data();
                gRegion_code.id = vregionData.id;
                // lấy api để load vào modal
                getregionbyregionID();
                $("#update-region-modal").modal("show");
            }
            function getregionbyregionID() {
                $.ajax({
                    url: "http://localhost:8080/region/details/" + gRegion_code.id,
                    type: "GET",
                    dataType: 'json',
                    success: function (responseObject) {
                        //debugger;
                        loadDataToModal(responseObject);
                    },
                    error: function (error) {
                        console.assert(error.responseText);
                    }
                });
            }
            // hàm load data to modal update
            function loadDataToModal(paramResponseObject) {
                $("#input-update-regionCode").val(paramResponseObject.regionCode);
                $("#input-update-regionName").val(paramResponseObject.regionName);
            }
            function onPageLoading() {

                //Khai báo dữ liệu
                //validate
                // lấy data từ server
                getAllregionbyapi();
                // Xử lý front-end
            }

            /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
            function getAllregionbyapi() {
                //gán dữ liệu
                var vUrlString = window.location.href; //đường đẫn gọi đến trang
                var vUrl = new URL(vUrlString);
                var vID = vUrl.searchParams.get("id");
                var vValid = kiemtraID(vID);
                if (vValid) {
                    $.ajax({
                        url: "http://localhost:8080/country/" + vID + "/regions",
                        type: "GET",
                        dataType: 'json',
                        success: function (responseObject) {
                            //debugger;
                            loadDataToTable(responseObject);
                        },
                        error: function (error) {
                            console.assert(error.responseText);
                            //window.location.href = "User.html";
                        }
                    });
                }
            }
            //hàm kiểm tra ID
            function kiemtraID(paramID) {
                if (paramID == null || paramID == "") {
                    alert("QueryString không có ID");
                    //window.location.href = "User.html";
                    return false;
                }
                return true;
            }
            // load data to table
            function loadDataToTable(paramResponseObject) {
                //Xóa toàn bộ dữ liệu đang có của bảng
                gregionTable.clear();
                //Cập nhật data cho bảng 
                gregionTable.rows.add(paramResponseObject);
                //Cập nhật lại giao diện hiển thị bảng
                gregionTable.draw();
            }
            // khi bấm nút Update trên modal
            function onBtnUpdateClick() {
                console.log(gRegion_code.id);
                //khai báo dữ liệu
                var vObjectRequest = {
                    regionCode: "",
                    regionName: ""
                }
                // gán dữ liệu
                vObjectRequest.regionCode = $("#input-update-regionCode").val();
                vObjectRequest.regionName = $("#input-update-regionName").val();
                //validate
                var validate = kiemtraCreateData(vObjectRequest);
                if (validate) {
                    //cập nhật trạng thái
                    updateRegion(vObjectRequest);
                }
            }
            //update region
            function updateRegion(paramObj) {
                $.ajax({
                    url: gBASE_URL + "update/" + gRegion_code.id,
                    type: "PUT",
                    data: JSON.stringify(paramObj),
                    contentType: "application/json; charset=utf-8",
                    dataType: 'json',
                    success: function (responseObject) {
                        //debugger;
                        handleUpdatetSuccess(responseObject.id);
                    },
                    error: function (error) {
                        console.assert(error.responseText);
                    }
                });
            }
            // hàm xử lý sự kiện delete region modal click
            function onBtnDeleteregionClick() {
                //khai báo dữ liệu
                //validate
                //gọi api
                $.ajax({
                    url: gBASE_URL + "delete/" + gRegion_code.id,
                    type: "DELETE",
                    contentType: "application/json; charset=utf-8",
                    success: function (paramRes) {
                        // B4: xử lý front-end
                        handleDeleteregionSuccess();
                    },
                    error: function (paramErr) {
                        console.log(paramErr.status);
                    }
                });
                //hiển thị thông tin
            }
            // hàm xử lý hiển thị front-end khi update Trạng thái thành công
            function handleUpdatetSuccess(paramObj) {
                onPageLoading();
                alert("Update region Id = " + paramObj + " thành công!");
                $("#update-region-modal").modal("hide");
            }
            // hàm xử lý hiển thị front-end khi sửa region thành công
            function handleDeleteregionSuccess() {
                onPageLoading();
                alert("Xóa region thành công!");
                $("#delete-confirm-modal").modal("hide");
            }
            function onBtnDeleteConfirmregionClick(paramChiTietButton) {
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramChiTietButton).parents('tr');
                //Lấy datatable row
                var vDatatableRow = gregionTable.row(vRowSelected);
                //Lấy data của dòng 
                var vregionData = vDatatableRow.data();
                gRegion_code.id = vregionData.id;
                // lấy api để load vào modal
                $("#delete-confirm-modal").modal("show");
            }
            function onBtnToDistrictClick(paramChiTietButton) {
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramChiTietButton).parents('tr');
                //Lấy datatable row
                var vDatatableRow = gregionTable.row(vRowSelected);
                //Lấy data của dòng 
                var vOrderData = vDatatableRow.data();
                gRegion_code.id = vOrderData.id;
                var vUrlString = window.location.href; //đường đẫn gọi đến trang
                var vUrl = new URL(vUrlString);
                var vID = vUrl.searchParams.get("id");
                // location trang mới
                var vUrlSiteToOpen = "District.html" +
                    "?id=" + gRegion_code.id + "&kd=" + vID;
                window.location.href = vUrlSiteToOpen;

            }
        });
    </script>
</body>

</html>